{
  "AbilityMixins": [
    {
      "$type": "AttachZoneTagWithModifierMixin",
      "ConfigList": [
        {
          "ModifierNameList": [
            "BtoAModifier"
          ],
          "ZoneTag": "YanagiStanceA"
        },
        {
          "ModifierNameList": [
            "AtoBModifier"
          ],
          "ZoneTag": "YanagiStanceB"
        }
      ]
    },
    {
      "$type": "ActionsOnPropertyChangeMixin",
      "DoInitialCheck": false,
      "PropertyActions": [
        {
          "CustomPropertyType": "Int_Stance",
          "CustomReferMaxPropertyType": "MaxInt_Stance",
          "IsUsePercentage": false,
          "PropertyType": "Custom",
          "ReferMaxPropertyType": "Custom",
          "ValueRangeActions": [
            {
              "LowToValueActions": [
                {
                  "$type": "RemoveModifier",
                  "ModifierName": "FreeStateAModifier",
                  "Target": "Self"
                },
                {
                  "$type": "ApplyModifier",
                  "ModifierName": "FreeStateBModifier",
                  "Target": "Self"
                }
              ],
              "Val": 1
            },
            {
              "HighToValueActions": [
                {
                  "$type": "RemoveModifier",
                  "ModifierName": "FreeStateBModifier",
                  "Target": "Self"
                },
                {
                  "$type": "ApplyModifier",
                  "ModifierName": "FreeStateAModifier",
                  "Target": "Self"
                }
              ],
              "Val": 0
            }
          ]
        }
      ]
    }
  ],
  "AbilityName": "Yanagi_StateBuff",
  "AbilitySpecials": {
    "AS_AddedElecDamageRatio_StateBuff": {
      "Value": 0.2
    },
    "AS_AddedenRatio_StateBuff": {
      "Value": 0.1
    },
    "AS_FreeStateDuration": {
      "Value": 8
    }
  },
  "AbilityStacking": "Unique",
  "DefaultModifier": {
    "OnAdded": [
      {
        "$type": "ApplyModifier",
        "ModifierName": "StanceABuffModifier",
        "Target": "Self"
      }
    ]
  },
  "Modifiers": {
    "AtoBModifier": {
      "Duration": -1,
      "ModifierStacking": "Unique",
      "OnAdded": [
        {
          "$type": "SetAnimCtrlerParamAction",
          "IntVal": 1,
          "ParamName": "Int_Stance",
          "ParamType": 3,
          "Target": "Self"
        },
        {
          "$type": "ModifyProperty",
          "Amount": 1,
          "CustomPropertyType": "Int_Stance",
          "IsUsePercentage": false,
          "PropertyModifyFunction": "Replace",
          "PropertyType": "Custom"
        },
        {
          "$type": "ApplyModifier",
          "ModifierName": "StanceBBuffModifier",
          "Target": "Self"
        }
      ]
    },
    "BtoAModifier": {
      "Duration": -1,
      "ModifierStacking": "Unique",
      "OnAdded": [
        {
          "$type": "SetAnimCtrlerParamAction",
          "IntVal": 0,
          "ParamName": "Int_Stance",
          "ParamType": 3,
          "Target": "Self"
        },
        {
          "$type": "ModifyProperty",
          "Amount": 0,
          "CustomPropertyType": "Int_Stance",
          "IsUsePercentage": false,
          "PropertyModifyFunction": "Replace",
          "PropertyType": "Custom"
        },
        {
          "$type": "ApplyModifier",
          "ModifierName": "StanceABuffModifier",
          "Target": "Self"
        }
      ]
    },
    "FreeStateAModifier": {
      "DelayHandlers": [
        {
          "DelayTime": "%AS_FreeStateDuration",
          "TimeUpActions": [
            {
              "$type": "RemoveModifier",
              "ModifierName": "StanceBBuffModifier",
              "Target": "Self"
            }
          ]
        }
      ],
      "Duration": -1,
      "ModifierStacking": "Replace"
    },
    "FreeStateBModifier": {
      "DelayHandlers": [
        {
          "DelayTime": "%AS_FreeStateDuration",
          "TimeUpActions": [
            {
              "$type": "RemoveModifier",
              "ModifierName": "StanceABuffModifier",
              "Target": "Self"
            }
          ]
        }
      ],
      "Duration": -1,
      "ModifierStacking": "Replace"
    },
    "StanceABuffModifier": {
      "Duration": -1,
      "ModifierStacking": "Unique",
      "OnAdded": [
        {
          "$type": "ApplyModifier",
          "ModifierName": "StanceAExtraModifier",
          "Target": "Self"
        },
        {
          "$type": "ModifyProperty",
          "Amount": 1,
          "CustomPropertyType": "Int_A_StanceBuff",
          "IsUsePercentage": false,
          "PropertyModifyFunction": "Replace",
          "PropertyType": "Custom"
        }
      ],
      "OnBeingHitPre": [
        {
          "$type": "SetRBLOffsetAction",
          "Predicates": [
            {
              "$type": "ByIsInZoneTags",
              "Tags": [
                "NormalAttackActing"
              ],
              "Target": "Self"
            }
          ],
          "RBLOffset": 1,
          "Tag": "StanceARBLOffset",
          "Target": "Self"
        }
      ],
      "OnBeingHitResolved": [
        {
          "$type": "UnsetRBLOffsetAction",
          "Tag": "StanceARBLOffset",
          "Target": "Self"
        }
      ],
      "OnRemoved": [
        {
          "$type": "RemoveModifier",
          "ModifierName": "StanceAExtraModifier",
          "Target": "Self"
        },
        {
          "$type": "ModifyProperty",
          "Amount": 0,
          "CustomPropertyType": "Int_A_StanceBuff",
          "IsUsePercentage": false,
          "PropertyModifyFunction": "Replace",
          "PropertyType": "Custom"
        }
      ]
    },
    "StanceAExtraModifier": {
      "Duration": -1,
      "ModifierStacking": "Unique",
      "Properties": {
        "Actor_AddedDamageRatio_Elec": "%AS_AddedElecDamageRatio_StateBuff"
      }
    },
    "StanceBBuffModifier": {
      "Duration": -1,
      "ModifierStacking": "Unique",
      "OnAdded": [
        {
          "$type": "ApplyModifier",
          "ModifierName": "StanceBExtraModifier",
          "Target": "Self"
        },
        {
          "$type": "ModifyProperty",
          "Amount": 1,
          "CustomPropertyType": "Int_B_StanceBuff",
          "IsUsePercentage": false,
          "PropertyModifyFunction": "Replace",
          "PropertyType": "Custom"
        }
      ],
      "OnHitOther": [
        {
          "$type": "ModifyAttackDataAction",
          "Predicates": [
            {
              "$type": "ByOr",
              "Predicates": [
                {
                  "$type": "ByAnimTagList",
                  "TagList": [
                    "AttackNormal",
                    "Normal"
                  ]
                },
                {
                  "$type": "ByAnimTagList",
                  "TagList": [
                    "AttackNormal",
                    "Rush"
                  ]
                }
              ]
            }
          ],
          "PropertyKey": "BreakLevel_Delta",
          "PropertyValue": 1,
          "Target": "Caster"
        }
      ],
      "OnRemoved": [
        {
          "$type": "RemoveModifier",
          "ModifierName": "StanceBExtraModifier",
          "Target": "Self"
        },
        {
          "$type": "ModifyProperty",
          "Amount": 0,
          "CustomPropertyType": "Int_B_StanceBuff",
          "IsUsePercentage": false,
          "PropertyModifyFunction": "Replace",
          "PropertyType": "Custom"
        }
      ]
    },
    "StanceBExtraModifier": {
      "Duration": -1,
      "ModifierStacking": "Unique",
      "Properties": {
        "Actor_PenRatio": "%AS_AddedenRatio_StateBuff"
      }
    }
  }
}